; Play samples loaded by the host out through the D/A converter
; This code assumes that the Delanco Spry board is set up in the
; usual manner, i.e., with timer 2 triggering the A/D converter and
; the A/D conversion done signal fed to the TMS-32010's BIO/ line.
; Hence the "dummy conversions" done for timing.
;
; Protocol: On each clock tick, the 320 reads the 16-bit port
; and copies it to the D/A converter, whether the host is ready or not.
; The 320 also toggles the value in the 8-bit port between 0 and 1 after
; reading each sample to indicate readiness for a new value.  As usual,
; the host is responsible for setting the proper clock rate on timer 2.
;
; 21 January 1987 Phil Karn, KA9Q
;
zero:	equ	0
one:	equ	1
tmp:	equ	2

adport:	equ	3
daport:	equ	4
hsport:	equ	5
hdport:	equ	7

	b	start
	nop
	nop
	nop
	nop
	nop

start:	ldpk	0
	lack	0
	sacl	zero
	lack	1
	sacl	one

begin:	out	zero,hsport	; indicate phase 0

wait1:	bioz	read1		; wait for first clock tick
	b	wait1

read1:	in	tmp,hdport	; read data port
	out	tmp,daport	; write d/a converter
	in	tmp,adport	; clear BIO line
	out	tmp,hdport

	out	one,hsport	; indicate phase 1

wait2:	bioz	read2		; wait for second clock tick
	b	wait2

read2:	in	tmp,hdport	; read data port
	out	tmp,daport	; write d/a converter
	in	tmp,adport	; clear BIO line
	out	tmp,hdport

	b	begin		; start all over
	end
